/**************************************************
 * RCSId: $Id: hpt_write.c,v 1.2 2017/05/27 10:58:26 ralblas Exp $
 *
 * Project: WSAT
 * Author: R. Alblas
 *
 * History: 
 * $Log: hpt_write.c,v $
 * Revision 1.2  2017/05/27 10:58:26  ralblas
 * _
 *
 * Revision 1.1  2017/01/04 15:48:39  ralblas
 * Initial revision
 *
 *
 **************************************************/
/*******************************************************************
 * Copyright (C) 2000 R. Alblas. 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software. If not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
 * 02111-1307, USA.
 ********************************************************************/
// 1e sync: 00000000  a1 16 fd 71 9d 83 c9	13864 bytes=11091.2 words = 11090+1.2 words = 
// 2e sync: 00003628  a1 16 fd 71 9d 83 c9      11090 words=13862.5 bytes => 1.5 extra bytes
// 3e sync: 00006c50  a1 16 fd 71 9d 83 c9	nr_qwords=11092/4=2773 = 13865 -> skip last byte
//
// hpt: 1 frame = 13864 bytes = 11091.2 words (laatste 1,5 bytes onzin)
// C10: 1 frame = 27728 bytes = 22182.4 words (laatste 3 bytes onzin)

// hpt: wpl=11092, qwords=2773 (11091.2 naar boven afgerond)
// C10: wpl=22184, qwords=5546 (22182.4 naar boven afgerond)

#include "wsat.h"
#include "hrpt_funcs.h"
int write_hpt_line(PICINFO *pci,guint16 *pline)
{
  FILE *fp=pci->fp;
  int nr_qwords=pci->fri.words_per_line/4; 
  int i;
  unsigned char tmp[5];
  if (!fp) return 0;

  for (i=0; i<nr_qwords; i++)
  {
    memset(tmp,0,sizeof(tmp));
    tmp[0] =((*pline)>>2) & 0xff; // 1234567890 -> __12345678

    tmp[1] =((*pline)<<6) & 0xc0; // 1234567890 -> __90......
    pline++;
    tmp[1]+=((*pline)>>4) & 0x3f; // 1234567890 -> __..123456

    tmp[2] =((*pline)<<4) & 0xf0; // 1234567890 -> __7890....
    pline++;
    tmp[2]+=((*pline)>>6) & 0x0f; // 1234567890 -> __....1234

    tmp[3] =((*pline)<<2) & 0xfc; // 1234567890 -> __567890..
    pline++;
    tmp[3]+=((*pline)>>8) & 0x03; // 1234567890 -> __......12

    tmp[4] =((*pline)<<0) & 0xff; // 1234567890 -> __34567890
    pline++;

    if (i<nr_qwords-1)
    {
      fwrite(tmp,5,1,fp);
    }
    else
    {
      if (pci->file_type==FT_CHPT)
      {
        fwrite(tmp,4,1,fp);
        fwrite(tmp,4,1,fp);
      }
      else
      {
        fwrite(tmp,4,1,fp);
      }
    }
  }
  return 1;
}
