/**************************************************
 * RCSId: $Id: metop.h,v 1.2 2017/01/04 16:04:35 ralblas Exp $
 *
 * metop header file 
 * Project: WSAT
 * Author: R. Alblas
 *
 * History: 
 * $Log: metop.h,v $
 * Revision 1.2  2017/01/04 16:04:35  ralblas
 * _
 *
 *
 **************************************************/
/*******************************************************************
 * Copyright (C) 2000 WSAT. 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software. If not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
 * 02111-1307, USA.
 ********************************************************************/
typedef struct ccsds_prim_hdr
{
  int vers;                   // 3 bits
  int type;                   // 1 bit
  int sec_hdrflg;             // 1 bit
  int apid;                   // 11 bits
  int seq_flg;                // 2 bits: 3: user data heeft complete transport file incl LRIT
                              //         1: transport header en 1e deel LRIT
                              //         0: vervolg LRIT
                              //         2: laatste deel LRIT
  int pckt_seqcnt;            // 14 bits
  int pckt_len;               // 16 bits
} CCSDS_PRIM_HDR;


typedef struct ccsds_data_fld1
{			      //				NOAA
  unsigned int sec_hdr_day;   // 2 bytes days since 1-1-2000	w#9
  unsigned int sec_hdr_msec;  // 4 bytes ms of day		w#10,11,12
  unsigned int sec_hdr_usec;  // 2 bytes us of ms
  unsigned int sbt_sec;       // 3 bytes sec
  unsigned int sbt_subsec;    // 2 bytes sec/65536
} CCSDS_DATA_FLD1;

typedef struct appl_data
{
  int det_space_view[5][10];  // 50 bits / chan			w#53-102 (ch1-5)
  int electr_ramp_cal[5];     // 10 bits / chan			w#13- 17 (ch1-5)
  int tlm_ir_target_temp[5];  // 10 bits / chan			w#18- 20 (ch3-5)
  int tlm_patch_temp[5];      // 10 bits / chan			w#21	 (ch3)
  int det_ir_backscan[5][10]; // 50 bits / chan			w#23- 52 (ch3-5)
} CCSDS_APPL_DATA;

typedef struct ccsds
{
  CCSDS_PRIM_HDR hdr;
  CCSDS_DATA_FLD1 ccsds_data_fld;
  CCSDS_APPL_DATA ccsds_appl_data;
} CCSDS;

typedef struct m_pdu
{
  int fhp;
  unsigned char *data;
  int dlen;
} M_PDU;

typedef struct vcdu
{
  int version;
  int sc_id;
  int vc_id;
  unsigned int cnt;
  int replay;
  int spare;
  int dlen;
  unsigned char *data;
  struct m_pdu m_pdu;
  struct ccsds ccsds;
} VCDU;
