/**************************************************
 * RCSId: $Id: xtrack_basefunc.h,v 1.6 2017/01/10 21:50:58 ralblas Exp $
 *
 * Header orbit-related files.
 * Project: WSAT
 * Author: R. Alblas
 *
 * History: 
 * $Log: xtrack_basefunc.h,v $
 * Revision 1.6  2017/01/10 21:50:58  ralblas
 * _
 *
 * Revision 1.5  2017/01/04 16:18:31  ralblas
 * _
 *
 *
 **************************************************/
/*******************************************************************
 * Copyright (C) 2000 WSAT. 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software. If not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
 * 02111-1307, USA.
 ********************************************************************/
#ifndef XTRACK_BASEFUNC
#define XTRACK_BASEFUNC
//#include "wsat.h"
#include "sattrack.h"

SAT *Create_Sat(SAT **sat);
SAT *Remove_Sat(SAT *sat);
TRACK *Create_Track(TRACK *track);
void Remove_Tracks(TRACK *track);
void yday2mday_mon(struct tm *tmref);
int mktime_ntz(struct tm *tm);
struct tm mom_tm0(float);
float x2earthangle(float sat_height,SCANDIR scan_hor,int x,int xh,float alpha_max);
void calc_satpos(struct tm cur_tm,EPOINT *pos_subsat,DIRECTION *satdir,EPOINT *refpos,SAT *sat,ROTOR *rot);
void calcposearth(struct tm *cur_tm, int ms, EPOINT *pos_earth);
int calcpossat(struct tm *cur_tm, int cu_ms,KEPLER *,ORBIT *,EPOINT *);
void calc_x2satobs(KEPLER *kepler,ORBIT *orbit,EPOINT *,EPOINT *,int,float,int);
SAT *read_msat(FILE *fp,char *satnames_toload,SAT *sat);

//int read_norad_next_keps(FILE *fp,char *sat_name,KEPLER *kepler);
//int calc_orbitconst(KEPLER *kepler,ORBIT *orbit);
//SAT *Find_Sat(SAT *sat,char *satname);

#endif
