#include "wsat.h"
#include "hrpt_funcs.h"

extern PREFS prefs;

#define LAB_METOPwnd   "Test METOP"
#define LAB_GENAMAN   "Man"
#define LAB_GENAPUNC  "Ena punc."
#define LAB_GENARAND  "Ena rand"
#define LAB_DECAMAN   "Man "
#define LAB_DECAPUNC  "Ena punc. "
#define LAB_DECARAND  "Ena rand "
#define LAB_SYNCPUNC  "syncpunc"

static void set_ctrle(RECORDINFO *rdi)
{
  int tmp=0;
  tmp =  (rdi->ena_man_gen&1) + ((rdi->ena_punc_gen&1)<<1) + ((rdi->ena_rand_gen&1)<<2);
  tmp|=(((rdi->ena_man_dec&1) + ((rdi->ena_punc_dec&1)<<1) + ((rdi->ena_rand_dec&1)<<2))<<3);
  tmp|=(rdi->syncpunc_dec&3)<<6;
  usb_write_reg(&rdi->usb,0x18,tmp&0xff);
//printf("tmp=%x\n",tmp);
}

static void get_ctrle(RECORDINFO *rdi)
{
  int tmp=0;
  tmp=usb_read(rdi,0x18);
  rdi->ena_man_gen=tmp&1;
  rdi->ena_punc_gen=(tmp>>1)&1;
  rdi->ena_rand_gen=(tmp>>2)&1;

  tmp>>=3;
  rdi->ena_man_dec=tmp&1;
  rdi->ena_punc_dec=(tmp>>1)&1;
  rdi->ena_rand_dec=(tmp>>2)&1;
  rdi->syncpunc_dec=(tmp>>3)&0x3;
}

static void Record_Raw_Commands(GtkWidget *widget, gpointer data)
{
  GtkWidget *main_window=Find_Window(Find_Parent_Window(widget),Lab_Main);
  GtkWidget *metop_window=Find_Window(main_window,LAB_METOPwnd);
  RECORDINFO *rdi=Get_Recordinfo_db(widget);
  char *name;
  name=(char *)data;
// generator: [2:0]=rand_on/punc_on/man_set
// decoder:   [7:3]=vitsync[1:0]/rand_on/punc_on/man_set
  if (!strcmp(name,LAB_GENAMAN))
  {
    rdi->ena_man_gen=Get_Button(widget,LAB_GENAMAN);
    Sense_Button(metop_window,LAB_GENAPUNC,rdi->ena_man_gen);
    Sense_Button(metop_window,LAB_GENARAND,rdi->ena_man_gen);
    set_ctrle(rdi);
  }


  if (!strcmp(name,LAB_GENAPUNC))
  {
    rdi->ena_punc_gen=Get_Button(widget,LAB_GENAPUNC);
    set_ctrle(rdi);
  }

  if (!strcmp(name,LAB_GENARAND))
  {
    rdi->ena_rand_gen=Get_Button(widget,LAB_GENARAND);
    set_ctrle(rdi);
  }

  if (!strcmp(name,LAB_DECAMAN))
  {
    rdi->ena_man_dec=Get_Button(widget,LAB_DECAMAN);
    Sense_Button(metop_window,LAB_DECAPUNC,rdi->ena_man_dec);
    Sense_Button(metop_window,LAB_DECARAND,rdi->ena_man_dec);
    Sense_Button(metop_window,LAB_SYNCPUNC,rdi->ena_man_dec);
    set_ctrle(rdi);
  }

  if (!strcmp(name,LAB_DECAPUNC))
  {
    rdi->ena_punc_dec=Get_Button(widget,LAB_DECAPUNC);
    set_ctrle(rdi);
  }

  if (!strcmp(name,LAB_DECARAND))
  {
    rdi->ena_rand_dec=Get_Button(widget,LAB_DECARAND);
    set_ctrle(rdi);
  }

  if (!strcmp(name,LAB_SYNCPUNC))
  {
    rdi->syncpunc_dec= GTK_ADJUSTMENT(widget)->value;
    rdi->syncpunc_dec&=0x3;
    set_ctrle(rdi);
  }
}

void Menu_MetopTest(GtkWidget *widget,gpointer data)
{
  GtkWidget *main_window=Find_Parent_Window(widget);
  GtkWidget *metop_window;
  GtkWidget *w3,*wz;
  RECORDINFO *rdi=Get_Recordinfo_db(widget);

  if (!(metop_window=Create_Window(main_window,0,0,LAB_METOPwnd,NULL))) return;
/* Set policy to 'auto-resize' */
  gtk_window_set_policy((GtkWindow *)metop_window,FALSE,FALSE,TRUE);
  get_ctrle(rdi);

  w3=Create_ButtonArray("",Record_Raw_Commands,-5,
             LABEL,"Generator",
             CHECKI,LAB_GENAMAN,rdi->ena_man_gen,
             CHECKI,LAB_GENAPUNC,rdi->ena_punc_gen,
             CHECKI,LAB_GENARAND,rdi->ena_rand_gen,
             LABEL,"",
             LABEL,"Decoder",
             CHECKI,LAB_DECAMAN,rdi->ena_man_dec,
             CHECKI,LAB_DECAPUNC,rdi->ena_punc_dec,
             CHECKI,LAB_DECARAND,rdi->ena_rand_dec,
             SPIN,LAB_SYNCPUNC,"%d%d%d",rdi->syncpunc_dec,0,3,
            NULL);

  wz=Pack(NULL,'v',w3,1,NULL);
  gtk_container_add(GTK_CONTAINER(metop_window),wz);

  gtk_widget_show_all(metop_window);
  place_window(metop_window,0,0,prefs.sub_wnd_geom);
  if (!rdi->ena_man_gen)
  {
    Sense_Button(metop_window,LAB_GENAPUNC,FALSE);
    Sense_Button(metop_window,LAB_GENARAND,FALSE);
  }
  if (!rdi->ena_man_dec)
  {
    Sense_Button(metop_window,LAB_DECAPUNC,FALSE);
    Sense_Button(metop_window,LAB_DECARAND,FALSE);
    Sense_Button(metop_window,LAB_SYNCPUNC,FALSE);
  }
}
