#include "wsat.h"
#include "gtk/gtk.h"
#include "gdk/gdkkeysyms.h"

GtkWidget *wt[5];
GtkAdjustment *adjust;
static int enable_debug(int set)
{
  static int enable;
  if (set>0) enable=1;
  if (set<0) enable=0;
  return enable;
}

#define MAXLEN 150
void w_dbg(char *frmt,...)
{
  char str[MAXLEN];
  str[MAXLEN-5]=0;
  va_list arg;
  if (!enable_debug(0)) return;
  va_start(arg,frmt);
  vsnprintf(str,MAXLEN-5,frmt,arg);
  va_end(arg);
  if (strlen(str) == MAXLEN-5-1) strcat(str,"...\n");
  Add_Text(wt[1],120,str);
  {
    gtk_adjustment_set_value(adjust,1000000.);
    gtk_scrolled_window_set_vadjustment(wt[1],adjust);
  }
}


/*************************************
 * Create text-widget 
 *************************************/
GtkWidget *Create_Text1(char *name,gboolean editable,char *font)
{
  GtkWidget *text;
  GtkWidget *scroll_win;

  scroll_win = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_win),
                                        GTK_POLICY_AUTOMATIC,
                                        GTK_POLICY_AUTOMATIC);

  GtkTextBuffer *buffer;
  text=gtk_text_view_new();
  if (font)
  {
    PangoFontDescription *font_desc;
    font_desc = pango_font_description_from_string(font);
    gtk_widget_modify_font (text, font_desc);
    pango_font_description_free(font_desc);
  }
  gtk_container_add(GTK_CONTAINER(scroll_win),text);
  if (name) gtk_object_set_data(GTK_OBJECT(text),WDGT_ID,(gpointer)name);

  buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(text));
  gtk_object_set_data(GTK_OBJECT(scroll_win),"TEXT_ID",(gpointer)buffer);

  gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(text),TRUE);
  gtk_text_view_set_editable(GTK_TEXT_VIEW(text),editable);
  gtk_widget_show(scroll_win);
  gtk_widget_show(text);
  text=text->parent;
  return text;
}

static void func(GtkWidget *widget,gpointer data)
{
  char *name=(char *)data;

  if (!strcmp(name,"clear"))
  {
    Clear_Text(wt[1]);
  }

  if (!strcmp(name,"disabled/enabled"))
  {
    if (Update_Togglelabel(widget))
    {
      enable_debug(1);
      Set_Widgetcolor(widget,'b',0,0xff,0);   // button 'green'
    }
    else
    {
      enable_debug(-1);
      Set_Widgetcolor(widget,'b',0xff,0,0);   // button 'red'
    }
  }
}

GtkWidget *nb_debug()
{
  wt[1]=Create_Text1("x",FALSE,NULL);
  wt[2]=Create_Toggle("disabled/enabled",func,FALSE);
  wt[3]=Create_Button("clear",func);
  wt[2]=SPack(NULL,"h",wt[2],"1",wt[3],"E1",NULL);
  wt[0]=Pack(NULL,'v',wt[1],1,wt[2],1,NULL);
  Clear_Text(wt[1]);
  adjust=gtk_adjustment_new(100.,0.,100.,1.,1.,1.);
//  wt[5]=adjust; // (GtkTextBuffer *)gtk_object_get_data(GTK_OBJECT(wt[1]),"TEXT_ID");
//printf("%x\n",wt[5]);
  return wt[0];
}
