/**************************************************
 * RCSId: $Id: jpeg_write.c,v 1.2 2017/04/11 20:08:34 ralblas Exp $
 *
 * jpeg related routines
 * Project: WSAT
 * Author: R. Alblas
 *
 * History: 
 * $Log: jpeg_write.c,v $
 * Revision 1.2  2017/04/11 20:08:34  ralblas
 * _
 *
 * Revision 1.1  2016/12/09 13:49:15  ralblas
 * Initial revision
 *
 *
 **************************************************/
/*******************************************************************
 * Copyright (C) 2000 R. Alblas. 
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software. If not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
 * 02111-1307, USA.
 ********************************************************************/
#include <stdio.h>
#include "wsat.h"
#if _JPEG_
int write_jpghdr_ext(FILE *fp,int width,int height,int depth,int quality);
void write_jpg_line(PICINFO *pc,guint16 *rl,guint16 *gl,guint16 *bl);
int write_jpgline(char *str);

int write_jpg_header(PICINFO *pc)
{
  return write_jpghdr_ext(pc->fp,pc->width,pc->height,8,pc->jpg_quality);
}

void write_jpg_line(PICINFO *pc,guint16 *rl,guint16 *gl,guint16 *bl)
{
  char *rgb;
  int i;
  rgb=malloc(pc->width*3);
  for (i=0; i<pc->width; i++)
  {
    rgb[i*3+0]=rl[i];
    rgb[i*3+1]=gl[i];
    rgb[i*3+2]=bl[i];
  }
  write_jpgline(rgb);
  free(rgb);
}

#endif
