#include <stdlib.h>
#include "wsat.h"
#include "hrpt_funcs.h"
//#include "track.h"
#define Lab_Testwnd "Test"
#define Lab_Testwnd2 "Test2"
#define LAB_ADDR "!address"
#define LAB_DATI "!data in"
#define LAB_DATO "!data out"
#define LAB_RGM "Test regmap"
#define LAB_READ "Read "
#define LAB_RD "Read"
#define LAB_WR "Write"
#define LAB_OU "Open USB"
#define LAB_CU "Close USB"
#define LAB_OCU "!ocu"

#define LAB_I2C "Test i2c"
#define LAB_I2CADDR "!i2caddr"
#define LAB_I2CBYTE1 "!i2cbyte1"
#define LAB_I2CBYTE2 "!i2cbyte2"
#define LAB_I2CBYTE3 "!i2cbyte3"
#define LAB_I2CBYTE4 "!i2cbyte4"
#define LAB_I2CSEND "Send i2c"

#define LAB_DEQC      "Test diseqc"
#define LAB_DEQCADDR  "!deqcaddra"
#define LAB_DEQCADDRb "!deqcaddrb"
#define LAB_DEQCCMD   "!commanda"
#define LAB_DEQCCMDb  "!commandb"
#define LAB_DEQCDAT0  "!deqcdat0a"
#define LAB_DEQCDAT0b "!deqcdat0b"
#define LAB_DEQCDAT1  "!deqcdat1a"
#define LAB_DEQCDAT1b "!deqcdat1b"
#define LAB_DEQCPOS   "!deqcposa"
#define LAB_DEQCPOSb  "!deqcposb"
#define LAB_DISLIMITS "Disable limits"
#define LAB_STOP      "Stop"
#define LAB_NSTOP     "NOODStop"
#define LAB_STORM     "Storm"
#define LAB_DRIVEEAST "Drive East"
#define LAB_DRIVEWEST "Drive West"
#define LAB_DEQCSEND1 "Send diseqc 1"
#define LAB_DEQCSEND2 "Send diseqc 2"
#define LAB_CONT      "send cont"

#define LAB_ERGM "RGM"
#define LAB_EI2C "I2C"
#define LAB_EDEQ "DEQ"

PREFS prefs;
static int i2c_addr=0xc2;
static int i2c_data[4];

/*
typedef struct diseqc
{
  int addr;
  int cmd;
  int data[2];
  int nr;
} DISEQC;
*/
//DISEQC diseqc;//={0x31,0x6e,0,0,0};

static void do_i2c(RECORDINFO *rdi)
{
  int act=0x03;
  int i;
  usb_write_reg(&rdi->usb,A_SERDATA,i2c_addr);
  usb_write_reg(&rdi->usb,A_SERCTRL,act);               // active
  for (i=0; i<4; i++)
  {
    usb_write_reg(&rdi->usb,A_SERDATA,i2c_data[i]);
    if (i==3) act=1;
    usb_write_reg(&rdi->usb,A_SERCTRL,act);             // send
  }
  usb_write_reg(&rdi->usb,A_SERCTRL,0x00);              // stop
//printf("DOE\n");
}

#ifdef XXX
static void do_dqc(RECORDINFO *rdi)
{
printf("WR#%x: %x  %x  %x  %x\n",diseqc.nr,diseqc.addr,diseqc.cmd,diseqc.data[0],diseqc.data[1]);
  usb_write_reg(rdi,A_DISEQ_ADR,diseqc.addr);
  usb_write_reg(rdi,A_DISEQ_CMD,diseqc.cmd);
  usb_write_reg(rdi,A_DISEQ_DAT1,diseqc.data[0]); 
  usb_write_reg(rdi,A_DISEQ_DAT2,diseqc.data[1]); 
  if (diseqc.nr==1)
    usb_write_reg(rdi,A_SERCTRL,0x60); // bit 6 =send, 5=2e
  else
    usb_write_reg(rdi,A_SERCTRL,0x40); // bit 6 = send
}
#endif

#ifdef NOGNIETGEBRUIKT
static void rd_diseqc(RECORDINFO *rdi)
{
  DISEQC diseqcrd;
  memset(&diseqcrd,0,sizeof(diseqcrd));
  dis_dat(rdi);
  usb_flush_tx(rdi);
  usb_read_reg(rdi,A_DISEQ_ADR,&diseqcrd.addr);
  usb_read_reg(rdi,A_DISEQ_CMD,&diseqcrd.cmd);
  usb_read_reg(rdi,A_DISEQ_DAT1,&diseqcrd.data[0]); 
  usb_read_reg(rdi,A_DISEQ_DAT2,&diseqcrd.data[1]); 
  usb_read_reg(rdi,A_SERCTRL,&diseqcrd.nr); 
printf("RD#%x: A=%x  C=%x  D1=%x  D2=%x\n",diseqcrd.nr&0x60,diseqcrd.addr,diseqcrd.cmd,diseqcrd.data[0],diseqcrd.data[1]);
}
#endif

static int deqcont(gpointer pointer)
{
  RECORDINFO *rdi=(RECORDINFO *)pointer;

  usb_write_reg(&rdi->usb,A_SERCTRL,0x40); // bit 6 = send
  usb_write_reg(&rdi->usb,A_SERCTRL,0x60); // bit 6 = send, 5=2e
  return 1;
}
int adr_arr[]={0,1,2,3,4,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,-1};
char *bl_arr[]=
{
  "","mode","","","",   // 0...4
  "","","","","","",    // 8-13,
  "","","","","","",    // 14-20,
  "gen: div lsb","gen: div msb","dec: div lsb","dec: div msb",""
};

static void flick_but(GtkWidget *widget,char *lab_but)
{
  GtkWidget *wnd=Find_Parent_Window(widget);
  Set_Button(widget,lab_but,TRUE);
  Set_Buttoncolor(Find_Widget(wnd,lab_but),0xf00);
  while (g_main_iteration(FALSE));
  g_usleep(50000);
  Set_Buttoncolor(Find_Widget(wnd,lab_but),0xddd);
  while (g_main_iteration(FALSE));
}

static int dstorm_x(gpointer gp)
{
  GtkWidget *widget=(GtkWidget *)gp;
  flick_but(widget,LAB_DEQCSEND1);
  return 0;
}

static int dstorm_y(gpointer gp)
{
  GtkWidget *widget=(GtkWidget *)gp;
  flick_but(widget,LAB_DEQCSEND2);
  return 0;
}

static void set_posa(GtkWidget *widget,float val,DISEQC *diseqc)
{
  *diseqc=val2diseqc(val,prefs.rotor.deg2step,prefs.rotor.inv_x,prefs.rotor.xy_rotorlim);
  Set_Entry(widget,LAB_DEQCADDR,"%x",diseqc->addr);
  Set_Entry(widget,LAB_DEQCCMD,"%x",diseqc->cmd);
  Set_Entry(widget,LAB_DEQCDAT0,"%x",diseqc->data[0]);
  Set_Entry(widget,LAB_DEQCDAT1,"%x",diseqc->data[1]);
  Set_Adjust(widget,LAB_DEQCPOS,"%d",(int)val);
}
static void set_posb(GtkWidget *widget,float val,DISEQC *diseqc)
{
  *diseqc=val2diseqc(val,prefs.rotor.deg2step,prefs.rotor.inv_x,prefs.rotor.xy_rotorlim);
  Set_Entry(widget,LAB_DEQCADDRb,"%x",diseqc->addr);
  Set_Entry(widget,LAB_DEQCCMDb,"%x",diseqc->cmd);
  Set_Entry(widget,LAB_DEQCDAT0b,"%x",diseqc->data[0]);
  Set_Entry(widget,LAB_DEQCDAT1b,"%x",diseqc->data[1]);
  Set_Adjust(widget,LAB_DEQCPOSb,"%d",(int)val);
}

static void test_usbcommands(GtkWidget *widget, gpointer dat)
{
  RECORDINFO *rdi=Get_Recordinfo_db(widget);
  static DISEQC diseqc1,diseqc2;
  char *name=(char *)dat;
  int addr=Get_Adjust(widget,LAB_ADDR);
  static int data; // =Get_Adjust(widget,LAB_DATI);
#ifdef __ADD_USB__
  if (!strcmp(name,LAB_DATI))
  {
    data=strtol(Get_Entry(widget,name),NULL,16);
  }

  if (!strcmp(name,LAB_ERGM))
  {
    Show_Button(widget,LAB_RGM,Get_Button(widget,LAB_ERGM));
    while (g_main_iteration(FALSE));
    gdk_window_resize(Find_Parent_Window(widget)->window,0,0);
  }
  if (!strcmp(name,LAB_EI2C))
  {
    Show_Button(widget,LAB_I2C,Get_Button(widget,LAB_EI2C));
    while (g_main_iteration(FALSE));
    gdk_window_resize(Find_Parent_Window(widget)->window,0,0);
  }
  if (!strcmp(name,LAB_EDEQ))
  {
    Show_Button(widget,LAB_DEQC,Get_Button(widget,LAB_EDEQ));
    while (g_main_iteration(FALSE));
    gdk_window_resize(Find_Parent_Window(widget)->window,0,0);
  }


  if (!strcmp(name,LAB_RD))
  {
    dis_dat(&rdi->usb);
    usb_flush_tx(&rdi->usb);
    usb_read_reg(&rdi->usb, addr,&data);
    Set_Entry(widget,LAB_DATO,"  %02x",data);
  }
  if (!strcmp(name,LAB_WR))
  {
    usb_write_reg(&rdi->usb, addr, data);
  }
  if (!strcmp(name,LAB_OU))
  {
    usb_init_connect(&rdi->usb);
  }
  if (!strcmp(name,LAB_CU))
  {
    usb_close_connect(&rdi->usb);
  }

  if (!strcmp(name,LAB_I2CADDR))
  {
    i2c_addr=strtol(Get_Entry(widget,LAB_I2CADDR),NULL,16);
  }
  if (!strcmp(name,LAB_I2CBYTE1))
  {
    i2c_data[0]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_I2CBYTE2))
  {
    i2c_data[1]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_I2CBYTE3))
  {
    i2c_data[2]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_I2CBYTE4))
  {
    i2c_data[3]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_I2CSEND))
  {
    do_i2c(rdi);
  }

  if (!strcmp(name,LAB_DEQCADDR))
  {
    diseqc1.addr=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCADDRb))
  {
    diseqc2.addr=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCCMD))
  {
    diseqc1.cmd=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCCMDb))
  {
    diseqc2.cmd=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCDAT0))
  {
    diseqc1.data[0]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCDAT0b))
  {
    diseqc2.data[0]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCDAT1))
  {
    diseqc1.data[1]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DEQCDAT1b))
  {
    diseqc2.data[1]=strtol(Get_Entry(widget,name),NULL,16);
  }
  if (!strcmp(name,LAB_DISLIMITS))
  {
    diseqc1.addr=0x31;  // azim rotor
    diseqc1.cmd=0x63;   // limits off
    diseqc2.addr=0x31;  // azim rotor
    diseqc2.cmd=0x63;   // limits off
    Set_Entry(widget,LAB_DEQCADDR,"%x",diseqc1.addr);
    Set_Entry(widget,LAB_DEQCADDRb,"%x",diseqc2.addr);
    Set_Entry(widget,LAB_DEQCCMD,"%x",diseqc1.cmd);
    Set_Entry(widget,LAB_DEQCCMDb,"%x",diseqc2.cmd);
    Set_Entry(widget,LAB_DEQCDAT0,"");
    Set_Entry(widget,LAB_DEQCDAT0b,"");
    Set_Entry(widget,LAB_DEQCDAT1,"");
    Set_Entry(widget,LAB_DEQCDAT1b,"");
  }
  if (!strcmp(name,LAB_STOP))
  {
    diseqc1.addr=0x31;  // azim rotor
    diseqc1.cmd=0x60;   // halt
    diseqc2.addr=0x31;  // azim rotor
    diseqc2.cmd=0x60;   // halt
    Set_Entry(widget,LAB_DEQCADDR,"%x",diseqc1.addr);
    Set_Entry(widget,LAB_DEQCADDRb,"%x",diseqc2.addr);
    Set_Entry(widget,LAB_DEQCCMD,"%x",diseqc1.cmd);
    Set_Entry(widget,LAB_DEQCCMDb,"%x",diseqc2.cmd);
    Set_Entry(widget,LAB_DEQCDAT0,"");
    Set_Entry(widget,LAB_DEQCDAT0b,"");
    Set_Entry(widget,LAB_DEQCDAT1,"");
    Set_Entry(widget,LAB_DEQCDAT1b,"");
  }
  if (!strcmp(name,LAB_NSTOP))
  {
    diseqc1.addr=0x31;  // azim rotor
    diseqc1.cmd=0x60;   // halt
    diseqc2.addr=0x31;  // azim rotor
    diseqc2.cmd=0x60;   // halt
    Set_Entry(widget,LAB_DEQCADDR,"%x",diseqc1.addr);
    Set_Entry(widget,LAB_DEQCADDRb,"%x",diseqc2.addr);
    Set_Entry(widget,LAB_DEQCCMD,"%x",diseqc1.cmd);
    Set_Entry(widget,LAB_DEQCCMDb,"%x",diseqc2.cmd);
    Set_Entry(widget,LAB_DEQCDAT0,"");
    Set_Entry(widget,LAB_DEQCDAT0b,"");
    Set_Entry(widget,LAB_DEQCDAT1,"");
    Set_Entry(widget,LAB_DEQCDAT1b,"");
    Set_Button(widget,LAB_DEQCSEND1);
    Set_Button(widget,LAB_DEQCSEND2);
  }
  if (!strcmp(name,LAB_DRIVEEAST))
  {
    diseqc1.addr=0x31;  // azim rotor
    diseqc1.cmd=0x68;   // east
    diseqc2.addr=0x31;  // azim rotor
    diseqc2.cmd=0x68;   // east
    Set_Entry(widget,LAB_DEQCADDR,"%x",diseqc1.addr);
    Set_Entry(widget,LAB_DEQCADDRb,"%x",diseqc2.addr);
    Set_Entry(widget,LAB_DEQCCMD,"%x",diseqc1.cmd);
    Set_Entry(widget,LAB_DEQCCMDb,"%x",diseqc2.cmd);
    Set_Entry(widget,LAB_DEQCDAT0,"");
    Set_Entry(widget,LAB_DEQCDAT0b,"");
    Set_Entry(widget,LAB_DEQCDAT1,"");
    Set_Entry(widget,LAB_DEQCDAT1b,"");
  }
  if (!strcmp(name,LAB_DRIVEWEST))
  {
    diseqc1.addr=0x31;  // azim rotor
    diseqc1.cmd=0x69;   // west
    diseqc2.addr=0x31;  // azim rotor
    diseqc2.cmd=0x69;   // west
    Set_Entry(widget,LAB_DEQCADDR,"%x",diseqc1.addr);
    Set_Entry(widget,LAB_DEQCADDRb,"%x",diseqc2.addr);
    Set_Entry(widget,LAB_DEQCCMD,"%x",diseqc1.cmd);
    Set_Entry(widget,LAB_DEQCCMDb,"%x",diseqc2.cmd);
    Set_Entry(widget,LAB_DEQCDAT0,"");
    Set_Entry(widget,LAB_DEQCDAT0b,"");
    Set_Entry(widget,LAB_DEQCDAT1,"");
    Set_Entry(widget,LAB_DEQCDAT1b,"");
  }

  if (!strcmp(name,LAB_DEQCPOS))
  {
    float val=Get_Adjust(widget,name);
    set_posa(widget,val,&diseqc1);
  }
  if (!strcmp(name,LAB_DEQCPOSb))
  {
    float val=Get_Adjust(widget,name);
    set_posb(widget,val,&diseqc2);
  }
  if (!strcmp(name,LAB_STORM))
  {
    set_posa(widget,prefs.rotor.storm.x,&diseqc1);
    set_posb(widget,prefs.rotor.storm.y,&diseqc2);

    if (prefs.rotor.storm_wait_x)
      gtk_timeout_add(prefs.rotor.storm_wait_x*1000,dstorm_x,(gpointer)widget);
    else
      flick_but(widget,LAB_DEQCSEND1);

    if (prefs.rotor.storm_wait_y)
      gtk_timeout_add(prefs.rotor.storm_wait_y*1000,dstorm_y,(gpointer)widget);
    else
      flick_but(widget,LAB_DEQCSEND2);
  }
  if (!strcmp(name,LAB_DEQCSEND1))
  {
    diseqc1.nr=0;
    do_dqc(&rdi->usb,diseqc1,TRUE);
  }

  if (!strcmp(name,LAB_DEQCSEND2))
  {
    diseqc2.nr=1;
    do_dqc(&rdi->usb,diseqc2,TRUE);
  }

  if (!strcmp(name,LAB_CONT))
  {
    static int to;
    if (!to) to=gtk_timeout_add(300,deqcont,rdi);
    else { gtk_timeout_remove(to); to=0; }

  }

#endif
  if (rdi->usb.ftHandle) 
    Set_Led(widget,LAB_OCU,0x0f0);
  else
    Set_Led(widget,LAB_OCU,0xf00);

}
static void test2_usbcommands(GtkWidget *widget, gpointer dat)
{
  RECORDINFO *rdi=Get_Recordinfo_db(widget);
  char *name=(char *)dat;
  int data=0;; 
  char lab[2][20];
  int i;

  if (!strcmp(name,LAB_OU))
  {
    usb_init_connect(&rdi->usb);
  }
  if (!strcmp(name,LAB_CU))
  {
    usb_close_connect(&rdi->usb);
  }
  for (i=0; adr_arr[i]>=0; i++)
  {
    sprintf(lab[0],"A_%02x",adr_arr[i]);
    sprintf(lab[1],"D_%02x",adr_arr[i]);
    if (!strcmp(name,lab[1]))
    {
      data=strtol(Get_Entry(widget,lab[0]),NULL,16);
      printf("%d  %s   %s  %x\n",i,lab[0],lab[1],data);
      usb_write_reg(&rdi->usb,adr_arr[i],data);
    }
  }
  if (!strcmp(name,LAB_READ))
  {
    usb_init_connect(&rdi->usb);
    dis_dat(&rdi->usb);
    usb_flush_tx(&rdi->usb);
    for (i=0; adr_arr[i]>=0; i++)
    {
      sprintf(lab[0],"A_%02x",adr_arr[i]);
      sprintf(lab[1],"D_%02x",adr_arr[i]);
      usb_read_reg(&rdi->usb,adr_arr[i],&data);
      Set_Entry(widget,lab[0],"0x%x",data);
//printf("%s  %x  %x\n",lab[0],adr_arr[i],data);
    }
  }
  if (rdi->usb.ftHandle) 
    Set_Led(widget,LAB_OCU,0x0f0);
  else
    Set_Led(widget,LAB_OCU,0xf00);
}

void Menu_Testusb(GtkWidget *widget,gpointer data)
{
  RECORDINFO *rdi=Get_Recordinfo_db(widget);
  GtkWidget *w[7];
  GtkWidget *wx[7];
  GtkWidget *test_window;
  GtkWidget *main_window;
  int i;
  char lab[20];
  main_window=Find_Parent_Window(widget);
/* Create new window or pop-up it if it already exist. */
  if (!(test_window=Create_Window(main_window,0,0,Lab_Testwnd,NULL)))
    return;
  w[1]=w[2]=w[3]=w[4]=NULL;

  w[1]=Create_ButtonArray("USB port",test_usbcommands,3,
         BUTTON,LAB_OU,
         LED,LAB_OCU,0x0,
         BUTTON,LAB_CU,
         CHECK,LAB_ERGM,
         CHECK,LAB_EI2C,
         CHECK,LAB_EDEQ,
    0);

  w[2]=Create_ButtonArray(NULL,test_usbcommands,2,
         LABEL,"Address",
         SPIN,LAB_ADDR,"%d%d%d",1,0,255,
         LABEL,"Data in",
//         SPIN,LAB_DATI,"%d%d%d",2,0,255,
         ENTRY,LAB_DATI,"%02x",0,
         LABEL,"Data out",
         ENTRY_NOFUNC,LAB_DATO,"%5s","",
         BUTTON,LAB_RD,
         BUTTON,LAB_WR,
         0);

  wx[5]=NULL;
  for (i=0; adr_arr[i]>=0; i++)
  {
    if ((i>=0x04) && (adr_arr[i]<0x14)) continue;
    #if _IQTEST1_ == 0
      if (adr_arr[i]>=0x14) continue;
    #endif
    wx[6]=Create_Label(bl_arr[i]);
    sprintf(lab,"A_%02x",adr_arr[i]);
    wx[2]=Create_Entry(lab,test2_usbcommands," %02x ",0);
    sprintf(lab,"D_%02x",adr_arr[i]);
    wx[3]=Create_Button(lab,test2_usbcommands);
    wx[4]=Pack(NULL,'h',wx[2],1,wx[3],1,wx[6],1,NULL);
    if (!wx[5]) wx[5]=Pack(NULL,'v',wx[4],1,NULL);
    else        wx[5]=Pack(NULL,'v',wx[5],1,wx[4],1,NULL);
  }
  wx[4]=Create_Button(LAB_READ,test2_usbcommands);
  wx[5]=Pack("",'v',wx[4],1,wx[5],1,NULL);

  wx[0]=Pack(LAB_RGM,'v',w[2],1,wx[5],1,NULL);

  // I2C
  {
    int hf=173950000;
    int mf=36450000;
    int stap=(hf+mf)/62500;
    i2c_addr=0xc2;
    i2c_data[0]=(stap>>8)&0xff;
    i2c_data[1]=stap&0xff;
    i2c_data[2]=0x8e;
    i2c_data[3]=0xa0;
      w[3]=Create_ButtonArray(LAB_I2C,test_usbcommands,2,
             LABEL,"I2C Address",
             ENTRY,LAB_I2CADDR ,"%02x ",i2c_addr,
             LABEL,"I2C div_msb",
             ENTRY,LAB_I2CBYTE1,"%02x ",i2c_data[0],
             LABEL,"I2C div_lsb",
             ENTRY,LAB_I2CBYTE2,"%02x ",i2c_data[1],
             LABEL,"I2C chargepump",
             ENTRY,LAB_I2CBYTE3,"%02x ",i2c_data[2],
             LABEL,"I2C band",
             ENTRY,LAB_I2CBYTE4,"%02x ",i2c_data[3],
             BUTTON,LAB_I2CSEND,
             LABEL,"",
             0);
  }

  // DiseqC
  {
    w[4]=Create_ButtonArray("Set positions",test_usbcommands,3,
           LABEL,"Address 0x",
           ENTRY,LAB_DEQCADDR ,"%02x ",0x31,
           ENTRY,LAB_DEQCADDRb ,"%02x ",0x31,
           LABEL,"Commands",
           ENTRY,LAB_DEQCCMD ,"%02x ",0x00,
           ENTRY,LAB_DEQCCMDb ,"%02x ",0x00,
           LABEL,"Data0",
           ENTRY,LAB_DEQCDAT0 ,"%02x ",0xE0,
           ENTRY,LAB_DEQCDAT0b ,"%02x ",0xE0,
           LABEL,"Data1",
           ENTRY,LAB_DEQCDAT1 ,"%02x ",0x20,
           ENTRY,LAB_DEQCDAT1b ,"%02x ",0x20,
           LABEL,"",
           LABEL,"",
           LABEL,"",
           LABEL,"GOTOxy",
           SPIN,LAB_DEQCPOS ,"%d%d%d ",90,0,180,
           SPIN,LAB_DEQCPOSb ,"%d%d%d ",90,0,180,
           LABEL,"Send comands",
           BUTTON,LAB_DEQCSEND1,
           BUTTON,LAB_DEQCSEND2,
           LABEL,"",
           CHECK,LAB_CONT,
           LABEL,"",
           0);

    w[5]=Create_ButtonArray("Set commands",test_usbcommands,2,
           BUTTON,LAB_DRIVEWEST,
           BUTTON,LAB_STOP,
           BUTTON,LAB_DRIVEEAST,
           BUTTON,LAB_DISLIMITS,
           0);

    w[6]=Create_ButtonArray("Do commands",test_usbcommands,1,
           BUTTON,LAB_NSTOP,
           BUTTON,LAB_STORM,
           0);

    w[5]=Pack(LAB_DEQC,'h',w[5],1,w[6],1,NULL);

    w[4]=Pack(LAB_DEQC,'v',w[4],1,w[5],1,NULL);
/*
      w[4]=Create_ButtonArray(LAB_DEQC,test_usbcommands,2,
             LABEL,"Address 0x",
             ENTRY,LAB_DEQCADDR ,"%02x ",0x31,
             LABEL,"Data0",
             ENTRY,LAB_DEQCDAT0 ,"%02x ",0xE0,
             LABEL,"Data1",
             ENTRY,LAB_DEQCDAT1 ,"%02x ",0x20,
             LABEL,"-----------",
             LABEL,"-----------",
             LABEL,"GOTOxy",
             SPIN,LAB_DEQCPOS ,"%d%d%d ",90,0,180,
             BUTTON,LAB_DEQCSEND1,
             BUTTON,LAB_DEQCSEND2,
             CHECK,LAB_CONT,
             0);
*/
  }



  
  w[0]=Pack(NULL,'v',w[1],1,wx[0],1,w[3],1,w[4],1,NULL);
  gtk_container_add(GTK_CONTAINER(test_window),w[0]);
  gtk_widget_realize(test_window); // realize, NOT show


  place_window(test_window,prefs.sub_wnd_x,prefs.sub_wnd_y,prefs.sub_wnd_geom);
  if (rdi->usb.ftHandle) 
    Set_Led(test_window,LAB_OCU,0x0f0);
  else
    Set_Led(test_window,LAB_OCU,0xf00);
  Show_Button(test_window,LAB_DEQC,0);
  Show_Button(test_window,LAB_I2C,0);
  Show_Button(test_window,LAB_RGM,0);
  while (g_main_iteration(FALSE));
  gdk_window_resize(test_window->window,0,0);
  gtk_widget_show(test_window); // Now show!S

}

/***************************************************************************/
#ifdef XXX
void Menu_Testusb2(GtkWidget *widget,gpointer data)
{
  int i;
  char lab[20];
  RECORDINFO *rdi=Get_Recordinfo_db(widget);
  GtkWidget *wx[7];
  GtkWidget *test_window;
  GtkWidget *main_window;
  main_window=Find_Parent_Window(widget);
  if (!(test_window=Create_Window(main_window,0,0,Lab_Testwnd2,NULL)))
    return;

  wx[1]=Create_ButtonArray("USB port",test2_usbcommands,3,
         BUTTON,LAB_OU,
         LED,LAB_OCU,0x0,
         BUTTON,LAB_CU,
         BUTTON,LAB_READ,
    0);

  wx[5]=NULL;
  for (i=0; adr_arr[i]>=0; i++)
  {
    if ((i>=4) && (adr_arr[i]<20)) continue;
    
    wx[6]=Create_Label(bl_arr[i]);
    sprintf(lab,"A_%02x",adr_arr[i]);
    wx[2]=Create_Entry(lab,test2_usbcommands," %02x ",0);
    sprintf(lab,"D_%02x",adr_arr[i]);
    wx[3]=Create_Button(lab,test2_usbcommands);
    wx[4]=Pack(NULL,'h',w[2],1,w[3],1,w[6],1,NULL);
    if (!wx[5]) wx[5]=Pack(NULL,'v',wx[4],1,NULL);
    else        wx[5]=Pack(NULL,'v',wx[5],1,wx[4],1,NULL);
  }
  wx[0]=Pack(NULL,'v',wx[1],1,wx[5],1,NULL);
  gtk_container_add(GTK_CONTAINER(test_window),w[0]);
  gtk_widget_show(test_window);
}

#endif
